; CC2Net.de - Systemtreiber 0001
; (c) by Andr Helbig
; Release: 02.12.2003
; sys0001.asm Version 1.2
; -LCD-Sys-Routinen
; -SR-Routinen fr 16bit SR an P1L.3(ST),P1L.4(Dta),P1L.5(SH)

$segmented
$model(medium)
$extend
$nomod166
$stdnames(reg164ci.def)
$NOLOCALS

	regdef	R1,R2,R3,R4,R5,R6,R7,R8,R9,R10,R11,R12,R13,R14,R15
;non-used Regs by IC-Subs: R3, R5, R8, R9, R10, R11, ((R14), R15)
;**************************************************************************************************************

; P1L.0 CC60IO 
; P1L.1 COUT60
; P1L.2 CC61IO
; P1L.3 COUT61
; P1L.4 CC62IO
; P1L.5 COUT62
; P1L.6 COUT63
; P1L.7 CTRAP 
; P1H.0 CC6POS0
; P1H.1 CC6POS1
; P1H.2 CC6POS2
; P1H.3 T7IN   
; P1H.4 CC24IO 
; P1H.5 CC25IO
; P1H.6 CC26IO
; P1H.7 CC27IO

P1L_		EQU	0FF04h

CMDSR		EQU     001011000B
CMDLCR		EQU     001011011B

; Definition der OS-Routinen
OSsegment	EQU	0
i2c_start	EQU	0872AH	
i2c_stop	EQU	08752H
i2c_ready	EQU	0877AH
i2c_write	EQU	08782H	; Returns Ackn in R4 Bit0 invers
i2c_read	EQU	0880EH	; Returns Data in R4, for readlast R12=1 else R12=0
POP_R4		EQU	0765AH	;uses: R4, R12, R13, R14
PUSH_R12	EQU	075D6H	;uses: R1, R2, R12, R13,R14,R15
POP_LONG	EQU	07680H  ;return in R4, R5
PUSH_LONG	EQU	075fEH  ;Value in R12, R13

userseg		SECTION CODE word at 3D540h
assume	dpp3:userseg


;************************************************************************************************************

; einzelnes Zeichen zum LCD an P1L senden
; Wertbergabe ber System-Stack
LCD_put	proc far
	BSET	CC60IO
	CALLR	LCD4bit
	POP	R1
	POP	R1
	RETS
LCD_put	endp

; String zum LCD an P1L senden
; Addr.bergabe ber System-Stack
print	proc far
	CALLS	OSsegment,POP_R4
	MOV	R1,R4
	ADD	R4,#30
	EXTS	#8,#1
	MOV	R13,[R4]
	SHR	R13,#8
	CALLR	_prnlen
 	POP	R1 
	POP	R1
	RETS	   
print	endp
	
; String oder Bytearray zum LCD an P1L senden (Lnge ber Stack)
; Addr.bergabe ber System-Stack
send	proc far
	CALLS	OSsegment,POP_R4	;hole Puffergre vom Stack
	MOV	R13,R4
	CALLS	OSsegment,POP_R4
	MOV	R1,R4
	CALLR	_prnlen
 	POP	R1	
	POP	R1
	RETS		
send	endp

; Anzahl gleicher Zeichen zum LCD an P1L senden
; ASCII und Anzahl ber Stack
sendchr	proc far
	CALLS	OSsegment,POP_R4	;Anzahl
	MOV	R13,R4
	CALLS	OSsegment,POP_R4	;ASCII

	BSET	CC60IO
	EXTR	#1
	OR	DP1L,#0F5h
	EXTS	#0,#1
	MOV	R6,P1L_
	AND	R6,#0Fh
_1a:
	EXTS	#8,#1
	CALLR	char
	CMPD1	R13,#1
	JMPR	cc_SGT,_1a

 	POP	R1	
	POP	R1
	RETS		
sendchr	endp

; einzelne Ziffer zum LCD an P1L senden
; Wertbergabe ber System-Stack
ziff	proc far
	BSET	CC60IO
	EXTR	#1
	OR	DP1L,#0F5h
	EXTS	#0,#1
	MOV	R6,P1L_
	AND	R6,#0Fh
	CALLS	OSsegment,POP_R4
	MOV	R1,#10
	EXTS	#0,#1
	MOV	0fe0eh,R4
	DIVU	R1
	EXTS	#0,#1
	MOV	R4,0fe0ch
	ADD	R4,#030h
	CALLR	char
	POP R1
	POP R1
	RETS
ziff	endp

; einzelnes Kommando zum LCD an P1L senden
; Wertbergabe ber System-Stack
LCD_cmd	proc far
	BCLR	CC60IO
	CALLR	LCD4bit
	POP	R1
	POP	R1
	RETS
LCD_cmd	endp

; einzelnes Nibble zum LCD an P1L senden
; Wertbergabe ber System-Stack
LCD8bit	proc far
	EXTS	#0,#1
	MOV	R6,P1L_
	AND	R6,#0Fh
	CALLS	OSsegment,POP_R4
	MOV	R5,R4
	CALLR	LCD_nib
	POP	R1
	POP	R1
	RETS
LCD8bit	endp

; Subroutine: Byte im 4Bit-Mode zum LCD an P1L senden
LCD4bit	proc near
	EXTR	#1
	OR	DP1L,#0F5h
	EXTS	#0,#1
	MOV	R6,P1L_
	AND	R6,#0Fh
	CALLS	OSsegment,POP_R4
	MOV	R5,R4
	CALLR	LCD_nib
	MOV	R5,R4
	SHL	R5,#4
	CALLR	LCD_nib
	RETN
LCD4bit	endp

; Subroutine: Nibble zum LCD an P1L senden
LCD_nib	proc near
	AND	R5,#0F0h
	OR	R5,R6
	EXTS	#0,#1
	MOV	P1L_,R5
	BSET	CC61IO
	MOV	R12,#00h
_1:
	CMPI1	R12,#07h
	JMPR	cc_SLT,_1
	BCLR	CC61IO
	RETN
LCD_nib	endp

; Subroutine: Zeichen zum LCD an P1L senden(f.Printfunktionen)
char	proc near
	MOV	R5,R4
	CALLR	LCD_nib
	MOV	R5,R4
	SHL	R5,#4
	CALLR	LCD_nib
	MOV	R12,#00h
_2:
	CMPI1	R12,#070h
	JMPR	cc_SLT,_2
	RETN
char	endp

; Subroutine: String zum LCD an P1L senden(f.Printfunktionen)
_prnlen	proc near
	BSET	CC60IO
	EXTR	#1
	OR	DP1L,#0F5h
	EXTS	#0,#1
	MOV	R6,P1L_
	AND	R6,#0Fh
_3:
	CMPD1	R13,#1
	JMPR	cc_ULT,_3a
	EXTS	#8,#1
	MOVB	RL4,[R1+]
	CALLR	char
	JMPR	cc_UC,_3
_3a:
	RETN
_prnlen	endp


; Station-Zusatzports(u.a.Relais/LCD-Bel.) setzen
; Wertbergabe ber System-Stack

;Ports nach Bitmuster setzen (16-Bit)
st_all	proc far
	CALLS	OSsegment,POP_R4	;state
	MOV	R3,R4
	;Data (16Bit) in R12 !!

	CALLS	OSsegment,POP_R4	;Port-Buffer-Addr	
	ADD	R4,#1
	CALLR	setbuf

	CALLR	st_shft
	POP R1
	POP R1
	RETS
st_all endp

;Einzel-Port setzen
st_one	proc far
	CALLS	OSsegment,POP_R4	;state
	MOV	R1,R4
	;Data (16Bit) in R12 !!
	CALLS	OSsegment,POP_R4	;port
	MOV	R2,R4
	CALLR	getbuf

	MOV	R12,#1
	SHL	R12,R2
	CMP	R1,#0
	JMPR	cc_NE,_6
	XOR	R12,#0FFFFh
	AND	R3,R12
	JMPR	cc_UC,_7
_6:
	OR	R3,R12
_7:
	CALLR	setbuf
	CALLR	st_shft
	POP R1
	POP R1
	RETS
st_one endp

;Einzel-Port umschalten (toggle)
st_tog	proc far
	CALLS	OSsegment,POP_R4	;port
	MOV	R2,R4
	CALLR	getbuf
	MOV	R12,#1
	SHL	R12,R2
	XOR	R3,R12

	CALLR	setbuf

	CALLR	st_shft
	POP R1
	POP R1
	RETS
st_tog endp

;Einzel-Port pulsen (2xtoggle)
st_puls proc far
	CALLS	OSsegment,POP_R4	;port
	MOV	R2,R4
	CALLR	getbuf

	PUSH	R3
	MOV	R12,#1
	SHL	R12,R2
	XOR	R3,R12

	CALLR	st_shft
	POP	R3
	CALLR	st_shft
	POP R1
	POP R1
	RETS
st_puls endp

getbuf	proc near
	CALLS	OSsegment,POP_R4	;portbuffer
	EXTS	#8,#1
	MOVB	RH3,[R4+]
	EXTS	#8,#1
	MOVB	RL3,[R4]
	RETN
getbuf	endp

setbuf	proc near
	EXTS	#8,#1
	MOVB	[R4],RL3
	EXTS	#8,#1
	MOVB	[-R4],RH3
	RETN
setbuf	endp

st_shft	proc near
	EXTR	#1
	OR	DP1L,#038h
	BCLR	COUT61
	BCLR	COUT62
	MOV	R13,#00h
_5:     ;for i=0 ... 15
	MOV	R14,R3
	ASHR	R14,#0Fh
	BMOVN	CC62IO,Z
	SHL	R3,#01h
	BSET	COUT62 ; Shift-Clock
	BCLR	COUT62
	CMPI1	R13,#0Fh
	JMPR	cc_SLT,_5 ; next for; jump if R13 < 0x0F

	BSET	COUT61 ; Strobe-Clock
	BCLR	COUT61

	RETN
st_shft endp	

;Einzel-Port abfragen
st_get	proc far
	CALLS	OSsegment,POP_R4	;port
	MOV	R2,R4
	CALLR	getbuf
	MOV	R12,#1
	SHL	R12,R2
	AND	R12,R3
;	CMP	R12,#0
	JMPR	cc_Z,_8
	MOV	R12,#0FFFFh
_8:
	CALLS	OSsegment,PUSH_R12	;state
	POP R1
	POP R1
	RETS
st_get endp

userseg	ENDS
	END





